//
//  UartModuleViewController.swift
//  Basic Chat
//
//  Created by Trevor Beaton on 12/4/16.
//  Copyright © 2016 Vanguard Logic LLC. All rights reserved.
// 115200 baud




import Foundation
import UIKit
import CoreBluetooth
import UIKit
import Charts // You need this line to be able to use Charts Library
import Accelerate
import Foundation

var tremorMagnitude = 0.0
var tremorBoolString = ""
var actionString = ""
var intensity = 0
class EMSViewController: UIViewController, CBPeripheralManagerDelegate, UITextViewDelegate, UITextFieldDelegate {
    
    //UI
    var centralManager : CBCentralManager!
    
    @IBOutlet var countingLabel: UILabel!
    @IBOutlet var intensityLabel: UILabel!
    @IBOutlet weak public var tremorMagLabel: UILabel!
    @IBOutlet var booltremorLabel: UILabel!
    @IBOutlet var actionLabel : UILabel!
    @IBOutlet var statusLabel : UILabel!
    
    @IBOutlet var ch1DownButton : UIButton!
    @IBOutlet var ch1upButton : UIButton!
    @IBOutlet var fupButton : UIButton!
    @IBOutlet var fdownButton : UIButton!
    @IBOutlet var disconnectButton : UIButton!
    
    @IBOutlet weak var switchControl: UISwitch!
    
    func save2text (magnitude: Double){ // appends data to text file ( remember you have to go hrough xcode devices save container right cick show
        let fileName = "TremorLog"
        let DocumentDirURL = try! FileManager.default.url(for: .documentDirectory, in: .userDomainMask, appropriateFor: nil, create: true)

        let fileURL = DocumentDirURL.appendingPathComponent(fileName).appendingPathExtension("txt")
        print("FilePath: \(fileURL.path)")

        let writeString = "\(NSDate())      \(magnitude)  \n"
        
        writeToFile(content: writeString, fileName: fileName)
        
//        do {
//            // Write to the file
//            try writeString.write(to: fileURL, atomically: true, encoding: String.Encoding.utf8)
//        } catch let error as NSError {
//            print("Failed writing to URL: \(fileURL), Error: " + error.localizedDescription)
//        }

      
    }
    
    
    func writeToFile(content: String, fileName: String) { // actually does the write operation for the text file
    
    let contentToAppend = content+"\n"
    let filePath = NSHomeDirectory() + "/Documents/" + fileName
    
    //Check if file exists
        if let fileHandle = FileHandle(forWritingAtPath: filePath) {
    //Append to file
    fileHandle.seekToEndOfFile()
            fileHandle.write(contentToAppend.data(using: String.Encoding.utf8)!)
    }
    else {
    //Create new file
    do {
        try contentToAppend.write(toFile: filePath, atomically: true, encoding: String.Encoding.utf8)
    } catch {
    print("Error creating \(filePath)")
    }
    }
    }
    
    
    @IBAction func zero_Ems (_ sender: Any){
        // zero amplitude of tremors
        ems.send_asci(asciVal: "Z")
        
    }
    
    
    @IBAction func sendp (_ sender: Any){
        // ask for new data to be sent from rsl
        ems.send_asci(asciVal: "P")
        
    }
    
    
    
    @IBAction func ControlStateSwitch(_ sender: UISwitch) {
        // if auto is on disable buttons
        if sender.isOn {
            ch1upButton.isEnabled = false
            ch1DownButton.isEnabled = false
            fupButton.isEnabled = false
            fdownButton.isEnabled = false
            actionString = "Entering automatic mode.... "
        } else {
            ch1upButton.isEnabled = true
            ch1DownButton.isEnabled = true
            fupButton.isEnabled = true
            fdownButton.isEnabled = true
            
            actionString = "Set in Manual mode "
        }
        
    }
    
    var numbers : [Double] = []
    var roots: [Double] = []
    var rArray: [Double] = []
    
    var counter = 0.0
    var timer = Timer()
    
    var magcounter = 0
    var magTimer = Timer()
    
    
    
    
    // called every time interval from the time
    @objc func magtimerAction() {
        tremorMagLabel.text = String(format:"%.2f", tremorMagnitude)
        booltremorLabel.text = tremorBoolString
        intensityLabel.text = "\(intensity)"
        statusLabel.text = bleConn
        actionLabel.text = actionString
        
        if bleConn == "Disconnected" {
            disconnectButton.isHidden = false
        }else{
             disconnectButton.isHidden = true
        }
        
        if (magcounter > 10){
            magcounter = 0
        }
        else{
            magcounter += 1
        }
        if tremorMagnitude <= 0.0 {
            tremorMagLabel.text = "OFF"
        }
    }
    
    
    
    
    @IBAction func ch1_up_pressed(_ sender: Any) {
        ems.press_C1up()
        //tremorMagLabel.text = "hdjfsakj"
    }
    @IBAction func ch1_down_pressed(_ sender: Any) {
        
        ems.press_C1down()
        
        
    }
    
    //    @IBAction func ch1_min(_ sender: Any){
    //
    //        ems.send_asci(asciVal: "O")
    //    }
    
  
    
    
    @IBAction func fup(_ sender: Any) {
        if !(counter > 0)  { // counter moves from 0 to 10... if set has not been pressed value will = 0.... so if it has not been pressed, press it
            ems.press_set()
            ems.press_set()


        }
        
        ems.press_right()
        reset()
        timer = Timer.scheduledTimer(timeInterval: 0.01, target: self, selector: #selector(timerAction), userInfo: nil, repeats: true)
        
    }
    
    @IBAction func fdown(_ sender: Any) {
        if !(counter > 0)  {
            ems.press_set()
            ems.press_set()


        }
        
        ems.press_left()
        reset()
        timer = Timer.scheduledTimer(timeInterval: 0.01, target: self, selector: #selector(timerAction), userInfo: nil, repeats: true)
        
    }
    
    
    
    // stop timer
    func reset() {
        timer.invalidate()
        counter = 0
        countingLabel.text = "\(counter)"
    }
    
    
    // called every time interval from the time
    @objc func timerAction() {
        if (counter > 10){
            reset()
        }
        else{
            counter = counter + 0.01
            countingLabel.text = "\(counter)"
        }
    }
    
    
    var peripheralManager: CBPeripheralManager?
    var peripheral: CBPeripheral!
    private var consoleAsciiText:NSAttributedString? = NSAttributedString(string: "")
    
    //Data
    @IBAction func DisconnectButton(_ sender: Any) {
       
        centralManager?.cancelPeripheralConnection(blePeripheral!)
        
        
    }
    
   
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        magTimer = Timer.scheduledTimer(timeInterval: 0.1, target: self, selector: #selector(magtimerAction), userInfo: nil, repeats: true)
        
        //Create and start the peripheral manager
        peripheralManager = CBPeripheralManager(delegate: self, queue: nil)
        //-Notification for updating the text view with incoming text
        updateIncomingData()
    }
    
    override func viewDidAppear(_ animated: Bool) {
    //    self.baseTextView.text = ""
        
        
    }
    
    override func viewDidDisappear(_ animated: Bool) {
        // peripheralManager?.stopAdvertising()
        // self.peripheralManager = nil
        super.viewDidDisappear(animated)
        NotificationCenter.default.removeObserver(self)
        
    }
    
    func updateIncomingData () {
        NotificationCenter.default.addObserver(forName: NSNotification.Name(rawValue: "Notify"), object: nil , queue: nil){
            notification in
            let appendString = "\n"
            let myFont = UIFont(name: "Helvetica Neue", size: 15.0)
            let myAttributes2 = [NSAttributedStringKey.font: myFont!, NSAttributedStringKey.foregroundColor: UIColor.red]
            let attribString = NSAttributedString(string: "[Incoming]: " + (characteristicASCIIValue as String) + appendString, attributes: myAttributes2)
            let newAsciiText = NSMutableAttributedString(attributedString: self.consoleAsciiText!)
           // self.baseTextView.attributedText = NSAttributedString(string: characteristicASCIIValue as String , attributes: myAttributes2)
            
            newAsciiText.append(attribString)
            
           // self.consoleAsciiText = newAsciiText
           // self.baseTextView.attributedText = self.consoleAsciiText
            
        }
    }
    
    
    
    
    

    
    // Write functions
    func writeValue(data: String){
        let valueString = (data as NSString).data(using: String.Encoding.utf8.rawValue)
        //change the "data" to valueString
        if let blePeripheral = blePeripheral{
            if let txCharacteristic = txCharacteristic {
                blePeripheral.writeValue(valueString!, for: txCharacteristic, type: CBCharacteristicWriteType.withResponse)
            }
        }
    }
    
    func writeCharacteristic(val: Int8){
        var val = val
        let ns = NSData(bytes: &val, length: MemoryLayout<Int8>.size)
        blePeripheral!.writeValue(ns as Data, for: txCharacteristic!, type: CBCharacteristicWriteType.withResponse)
    }
    
    
 
    
    func peripheralManagerDidUpdateState(_ peripheral: CBPeripheralManager) {
        if peripheral.state == .poweredOn {
            return
        }
        print("Peripheral manager is running")
    }
    
    //Check when someone subscribe to our characteristic, start sending the data
    func peripheralManager(_ peripheral: CBPeripheralManager, central: CBCentral, didSubscribeTo characteristic: CBCharacteristic) {
        print("Device subscribe to characteristic")
    }
    
    //This on/off switch sends a value of 1 and 0 to the Arduino
    //This can be used as a switch or any thing you'd like
   
    
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        self.view.endEditing(true)
    }
   
    func peripheralManagerDidStartAdvertising(_ peripheral: CBPeripheralManager, error: Error?) {
        if let error = error {
            print("\(error)")
            return
        }
    }
    
     func calculate(_ _values: [Double], fps: Double) -> Int {
        var values = _values
        // ----------------------------------------------------------------
        // Size Variables
        // ----------------------------------------------------------------
        let N = values.count
        let N2 = vDSP_Length(N/2)
        let LOG_N = vDSP_Length(log2(Float(values.count)))
        
        // ----------------------------------------------------------------
        // FFT & Variables Setup
        // ----------------------------------------------------------------
        let fftSetup: FFTSetupD = vDSP_create_fftsetupD(LOG_N, FFTRadix(kFFTRadix2))!
        
        var tempSplitComplexReal : [Double] = [Double](repeating: 0.0, count: N/2)
        var tempSplitComplexImag : [Double] = [Double](repeating: 0.0, count: N/2)
        var tempSplitComplex : DSPDoubleSplitComplex = DSPDoubleSplitComplex(realp: &tempSplitComplexReal, imagp: &tempSplitComplexImag)
        
        // ----------------------------------------------------------------
        // Forward FFT
        // ----------------------------------------------------------------
        
        var valuesAsComplex : UnsafeMutablePointer<DSPDoubleComplex>? = nil
        
        values.withUnsafeMutableBytes {
            valuesAsComplex = $0.baseAddress?.bindMemory(to: DSPDoubleComplex.self, capacity: values.count)
        }
        
        // Scramble-pack the real data into complex buffer in just the way that's
        // required by the real-to-complex FFT function that follows.
        vDSP_ctozD(valuesAsComplex!, 2, &tempSplitComplex, 1, N2);
        
        // Do real->complex forward FFT
        vDSP_fft_zripD(fftSetup, &tempSplitComplex, 1, LOG_N, FFTDirection(FFT_FORWARD));
        
        // ----------------------------------------------------------------
        // Get the Frequency Spectrum
        // ----------------------------------------------------------------
        
        var fftMagnitudes = [Double](repeating: 0.0, count: N/2)
        vDSP_zvmagsD(&tempSplitComplex, 1, &fftMagnitudes, 1, N2);
        
        // vDSP_zvmagsD returns squares of the FFT magnitudes, so take the root here
        for a in fftMagnitudes{
            let temp = sqrt(a)
            roots.append(temp)
        }
        // Normalize the Amplitudes
        var fullSpectrum = [Double](repeating: 0.0, count: N/2)
        vDSP_vsmulD(roots, vDSP_Stride(1), [1.0 / Double(N)], &fullSpectrum, 1, N2)
        roots.removeAll()
        
        var lineArray  = [ChartDataEntry]()
        let freqs = getFrequencies(N,fps: fps)
        
        //        for i in 0..<255{
        //
        //            let value = ChartDataEntry(x: Double(freqs[i]), y: fullSpectrum[i]) // here we set the X and Y status in a data chart entry
        //            lineArray.append(value) // here we add it to the data set
        //        }
        //
        //        let line2 = LineChartDataSet(values: lineArray, label: "Number") //Here we convert lineChartEntry to a LineChartDataSet
        //        line2.colors = [NSUIColor.blue] //Sets the colour to blue
        //        let data2 = LineChartData() //This is the object that will be added to the chart
        //        data2.addDataSet(line2) //Adds the line to the dataSet
        
        
        //        //chtChart.data = data2 //finally - it adds the chart data to the chart and causes an update
        //        line2.circleRadius = 0
        //        var max=0.0
        //        var f=0.0
        //        var avg=0.0
        //        var limit = 0.0
        //        var checker = 1
        
        
        
        
        // for i in 0..<255{
        
        //     avg = avg + fullSpectrum[i]
        // }
        //avg = avg / 256
        
        // limit = avg+avg*0.5
        
        //for i in 3..<8{
        
        //   if fullSpectrum[i] < limit{
        //     checker = 2
        //}
        // }
        
        // if checker == 2 {
        //    self.TremorBool.text = "Yes"
        //}else {
        //    self.TremorBool.text = "No"
        
        //}
        tremorMagnitude = 0.0
        for i in 0..<25{
            if freqs[i] >= 4 && freqs[i] <= 6 {
                tremorMagnitude = tremorMagnitude + fullSpectrum[i]
            }
            
            //            if fullSpectrum[i] > max {
            //                max = fullSpectrum[i]
            //                f=freqs[i]
            //
            //            }
            
        }
        // if (TMagLabel != nil) {
        //let s = String(tremorMagnitude)
        //secondViewController.TMagLabel.text = s
        
        // }
        
        print("tremorMagnitude \n")
        print(tremorMagnitude)
        
        let threshold = 35.0
        if tremorMagnitude > threshold {
            save2text(magnitude: tremorMagnitude)
            
            if switchControl.isOn{
                
                if (intensity < 100) {
                    intensity = intensity+1
                    ems.press_C1up()
                    actionString = "increasing amplitude"
                }
                
        }
            tremorBoolString = "Tremoring"
            print("Tremoring \n")
            
        }else{
            if switchControl.isOn{
                
                if (intensity > 0) {
                    intensity = intensity-1
                    ems.press_C1down()
                    actionString = "decreasing amplitude"
                }
                
            }
            tremorBoolString = "Not Tremoring"
            print("no tremors \n")
            
        }
        
        
        
        //print(f)
        
        //        if f >= 3 && f <= 7 {
        //            self.TremorBool.text = "Yes"
        //
        //        }else{
        //            self.TremorBool.text = "No"
        //        }
        
        
        
        
        // do not erase, tremor control logic notes
        // will use gradient descent as in machine learning to create the control system. Take Tremor magnitude ( see commented out code above) and place into array over past several FFT taken. Get the derivative of the signal.. look for direction of steepest decrease in tremor magintude ( aka
        // note do it with only one input at a time initially.. do frequency then amplitude then can look at pulse width... once have the abiltiy to to do it with one figure out how to incorporate all in a dimensional space larger then 2... should jsut be the parital of each then somehow combined?
        if switchControl.isOn{
            ems.send_asci(asciVal: "P")
        }
        
        print("freqs \n")
        print(freqs)
        print("fullSpectrum \n")
        print(fullSpectrum)
        fullSpectrum.removeAll()
        let check = 0x69
        return check
        
        
    }

    
    func getFrequencies(_ N: Int, fps: Double) -> [Double] {
        // Create an Array with the Frequencies
        let freqs = (0..<N/2).map {
            fps/Double(N)*Double($0)
        }
        
        return freqs
    }
    
    
}

